#|
Sequence Maker

Permission is granted for use, provided that author's name and copyright
are retained in this file. The author makes no warranties with respect to
this work.

Author: V.J. Manzo
E-mail: vj@vjmanzo.com
Website: www.vincemanzo.com
(c) 2008 Vincent Joseph Manzo


requires mgc.cl to save MIDI

|#

;; Mvt. 1 --> (save-as-midi "test4.mid" (my-make-sequence (list *voice1* *voice2* *voice3* *voice4* *voice5*) '(15 14 13 12 11) '(8000 4000 500 250 250) '(1 2 3 4 5) '(48000 16000 32000 0 0)))
;; Mvt. 2 --> (save-as-midi "test3.mid" (my-make-sequence (list *voice1* *voice2* *voice3* *voice4* *voice5*) '(8 6 4 3 4) '(2000 500 2000 4000 8000) '(1 2 3 4 5) '(0 16000 32000 48000 48000)))
;; Mvt. 3 --> (save-as-midi "test5.mid" (my-make-sequence (list *voice1* *voice2* *voice3* *voice4* *voice5*) '(15 8 4 8 8) '(500 500 1000 4000 4000) '(1 2 3 4 5) '(0 0 0 0 0)))

(defvar *mynotes* '(1 2 3))


;;each voice below is treated with certain canonic features (retrograde, inverse retrograde) 
(setq *voice1* (fit-to-range-complete *mynotes* 55 96))(setq *voice1* (fit-to-range-complete *mynotes* 55 96))
(setq *voice2* (reverse (fit-to-range *mynotes* 55 96)))
(setq *voice3* (reverse (fit-to-range *mynotes* 48 89)))
(setq *voice4* (fit-to-range-complete *mynotes* 36 79))
(setq *voice5* (fit-to-range-complete *mynotes* 24 67))



; (setq *mynotes* '(67 64 58 59 58 60 59 58 59 55 52 55 52 54 57 59 60)) <-- Mvt 1
; (setq *mynotes* '(12 9 5 4 0 5)) <-- Mvt 2
; (setq *mynotes* '(7 12 11 7 11 12 11 7 11 12 11 9 7 4 0)) <-- Mvt 3



;;returns X number of the list and removes the first element and shifts over one until the list is empty

(defun returns-sequenced-list (a-sequence sequence-length) 
  (if (null a-sequence) ()
    (append (firstn sequence-length a-sequence) (returns-sequenced-list (rest a-sequence) sequence-length))))
                     


;;makes cope events from pitch classes

(defun mCe (alist duration channel &optional (time 0)) 
  (if (null alist) ()
    (cons (list time (first alist) duration channel duration 127)
                  (mce (rest alist) duration channel (+ time duration)))))



(defun sequence-maker (list-of-sequences list-of-sequence-lengths list-of-durations list-of-channels list-of-ontimes)
  (if (null list-of-sequences) ()
    (cons (mce (returns-sequenced-list (first list-of-sequences)(first list-of-sequence-lengths))(first list-of-durations)(first list-of-channels)(first list-of-ontimes))
  (sequence-maker (rest list-of-sequences)(rest list-of-sequence-lengths)(rest list-of-durations)(rest list-of-channels)(rest list-of-ontimes)))))


(defun my-make-sequence (list-of-sequences list-of-sequence-lengths list-of-durations list-of-channels list-of-ontimes)
  (apply #'append (sequence-maker list-of-sequences list-of-sequence-lengths list-of-durations list-of-channels list-of-ontimes)))


;;;utilities

(defun firstn (n list)
  "(firstn 2 '(1 2 3 4)) (1 2)"
  (if (or (zerop n)(null list)) ()
      (cons (first list)
            (firstn (1- n)(rest list))))) 




